﻿import flash.filters.DropShadowFilter
import flash.filters.BevelFilter


class Earth
{
	private var movingMC: MovieClip;
	private var shadowEffect: DropShadowFilter;
	private var bevelEffect: BevelFilter;
	
	function Earth( tl: MovieClip )
	{
		init( tl );
	}	
	
	private function init( tl: MovieClip )
	{
		this.movingMC = tl.attachMovie( "Earth", "earth", tl.getNextHighestDepth( ), { _x: 200, _y: 200 } );
	}
	
	public function setEffectParams( param: Object )
	{
		//trace( "sol " + param.x  + ", " + param.y );
		
		//Lazy init del efecto y asignación de valores
		
		var distance: Number = param.distance * 100 / ( Stage.width/2 ) / 100;
		
		if ( this.shadowEffect == null )
		{
			this.shadowEffect = new DropShadowFilter( 16 * distance, 180+param.angle, 0x000000, .50/ distance, 4, 4, 1, 3, false, false, false);
			this.bevelEffect = new BevelFilter( 4* distance, 180 + param.angle, 0xFFFFFF, .90* distance, 0x000000, .60, 4, 4, 1, 3, "inner", false );
		}
		
		this.shadowEffect.angle = 180+ param.angle;
		this.shadowEffect.distance = 16*distance;
		this.shadowEffect.alpha = .50 / distance;
		
		this.bevelEffect.angle = 180 + param.angle;
		
		var myFilters: Array = Array( this.movingMC.filters );
		myFilters[ 0 ] = this.shadowEffect;
		myFilters[ 1 ] = this.bevelEffect;
		this.movingMC.filters = myFilters;				
	}
	
	public function getPosition( ): Object
	{
		return { x: this.movingMC._x, y: this.movingMC._y };
	}
}