﻿import mx.utils.Delegate

class SunController
{
	private var baseMC	: MovieClip;
	private var theSun	: Sun;
	private var theEarth: Earth;
	
	function SunController( baseMC: MovieClip )
	{
		this.baseMC = baseMC;
	}
	
	public function initApp( )
	{
		this.theEarth = new Earth( this.baseMC );

		this.theSun = new Sun( this.baseMC );
		
		this.theSun.addEventListener( "onDragging", this );
		this.theSun.addEventListener( "onDropped", this );
		
		//para iniciar bien
		this.frameClock( );
	}
	
	private function onDragging( )
	{
		this.baseMC.onEnterFrame = Delegate.create( this, frameClock );
	}
	
	private function onDropped( )
	{
		delete this.baseMC.onEnterFrame;
	}
	
	function distance(coord1: Object, coord2: Object ): Number
	{
		return Math.sqrt((coord2.x - coord1.x)*(coord2.x - coord1.x) + (coord2.y - coord1.y)*(coord2.y - coord1.y));
	}
	
	function angle( coord1: Object, coord2: Object ): Number
	{
		var dX = coord2.x - coord1.x;
		var dY = coord2.y - coord1.y;
		
		var tanAlpha = dY / dX;
		var angle = Math.atan( tanAlpha ) / ( Math.PI/180 );

		if ( dX< 0 )
		{
			angle+= 180;
		}
		
		if (dX> 0 && dY< 0)
		{
			angle += 360;
		}
		
		return angle;
	}	
	
	private function frameClock( )
	{
		var earthPosition	: Object = this.theEarth.getPosition( );
		var sunPosition		: Object = this.theSun.getPosition( );
		
		var distanceValue: Number = this.distance( earthPosition, sunPosition );
		var angleValue: Number = this.angle( earthPosition, sunPosition );
		
		
		//Hago el cálculo y paso todo encapsulado en un objeto
		this.theEarth.setEffectParams( { distance: distanceValue, angle: angleValue } );
	}
}